/*
 * mkmap.c - ޥåץեκ
 */
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>

void err_quit(char *msg);

int main(int argc, char *argv[])
{
    int fd;
    void *map;
    struct stat statbuf;
    
    /* ޥåפե򳫤 */
    if(argc != 2) {
        puts("USAGE: mkmap {ե}");
        exit(EXIT_FAILURE);
    }
    if((fd = open(argv[1], O_RDONLY)) < 0)
	err_quit("open");
    
    /* mmapΤ˥եĹ */
    fstat(fd, &statbuf);
    
    /* ϥեޥåפ */
    if((map = mmap(0, statbuf.st_size, PROT_READ, 
		   MAP_SHARED, fd, 0)) == MAP_FAILED)
        err_quit("mmap");
    printf("%p˥ޥåפ줿\n", &map);
    
    /* եĤƥޥåפ */
    close(fd);
    munmap(map, statbuf.st_size);
    exit(EXIT_SUCCESS);
}

void err_quit(char *msg)
{
    perror(msg);
    exit(EXIT_FAILURE);
}
