/*
 * mmcat.c - cat(1)ϥޥåפȤäƼ
 */
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>

void err_quit(char *msg);

int main(int argc, char *argv[])
{
    int fd;
    char *src;
    struct stat statbuf;

    /* ե򳫤 */
    if(argc != 2) {
        puts("USAGE: mmcat {ե}");
        exit(EXIT_FAILURE);
    }
    if((fd = open(argv[1], O_RDONLY)) < 0)
         err_quit("open");

    /* mmap뤿˥եĹ */
    fstat(fd, &statbuf);

    /* ϥեޥåפ */
    if((src = mmap(0, statbuf.st_size, PROT_READ, 
		   MAP_SHARED, fd, 0)) == MAP_FAILED)
        err_quit("mmap");

    /* 񤭽Ф򤹤 */
    write(STDOUT_FILENO, src, statbuf.st_size);

    /* ꡼󥢥åפ */
    close(fd);
    munmap(src, statbuf.st_size);

    exit(0);
}

void err_quit(char *msg)
{
    perror(msg);
    exit(EXIT_FAILURE);
}
