/*
 * adddb.c -  database Berkeley DB ǡ١˥쥳ɤä
 */
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include "db.h"

int main(void)
{
     DB *db;
     int ret;
     DBT key, value;

     ret = db_open("test.db", DB_BTREE, 
		   DB_CREATE, 0600, NULL, NULL, &db);
     if(ret) {
	  perror("db_open");
	  exit(EXIT_FAILURE);
     }

     /* ǽ˥/(key/value)Υڥ */
     memset(&key, 0, sizeof(key));
     memset(&value, 0, sizeof(value));
     /* ͤꤹ */
     key.data = "one";
     key.size = sizeof("one");
     value.data = "ץΥѥ";
     value.size = sizeof("ץΥѥ");
     /* ¸ */
     ret = db->put(db, NULL, &key, &value, DB_NOOVERWRITE);
     if(ret == DB_KEYEXIST) {
	  fprintf(stderr, " %s ¸ߤ\n", (char *)key.data);
	  exit(EXIT_FAILURE);
     } else if(ret) {
	  perror("put");
	  exit(EXIT_FAILURE);
     }
     
     db->close(db, 0);
     exit(EXIT_SUCCESS);
}
