/*
 * addmore.c - Berkeley DB ǡ١˥쥳ɤä
 */
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include "db.h"

int getstr(char buf[], int len);

int main(void)
{
     int ret, i = 0;
     char kbuf[80], vbuf[80];
     DB *db;
     DBT key, value;
     
     ret = db_open("test.db", DB_BTREE, 
		   DB_CREATE, 0600, NULL, NULL, &db);
     if(ret) {
	  perror("dbopen");
	  exit(EXIT_FAILURE);
     }
     memset(&key, 0, sizeof(key));
     memset(&value, 0, sizeof(value));
     
     
     /* ǽ˥(key/value)Υڥ */
     while(i < 5) {
	  fprintf(stdout, ": ");
	  ret = getstr(kbuf, 80);
	  if(ret >= 0) {
	       key.data = kbuf;
	       key.size = ret + 1;
	  } else {
	       perror("getstr key");
	       exit(EXIT_FAILURE);
	  }
	  fprintf(stdout, "ǡ: ");
	  ret = getstr(vbuf, 80);
	  if(ret >= 0) {
	       value.data = vbuf;
	       value.size = ret + 1;
	  } else {
	       perror("getstr data");
	       exit(EXIT_FAILURE);
	  }
	  /* ¸ */
	  ret = db->put(db, NULL, &key, &value, DB_NOOVERWRITE);
	  if(ret == DB_KEYEXIST) {
	       fprintf(stderr, " %s ¸ߤ\n", (char *)key.data);
	       exit(EXIT_FAILURE);
	  } else if(ret) {
	       perror("put");
	       exit(EXIT_FAILURE);
	  }
	  db->sync(db, 0);
	  ++i;
     }
     
     db->close(db, 0);
     exit(EXIT_SUCCESS);
}

/*
 * 1٤1ʸstdinʸ
 * (len - 1)ʸޤǤ¸
 * ¸ʸ֤
 */
int getstr(char buf[], int len)
{
     int c, i = 0;
     
     while((c = getchar()) != '\n' && i < len) {
	  buf[i] = c;
	  ++i;
     }
     buf[i] = '\0'; 
     return i;
}
