/*
 * cursor.c - Berkeley DB ǡ١ǥȤ
 */
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include "db.h"

int main(void)
{
     DB *db;
     DBC *dbc;
     DBT key, value;
     int ret;

     ret = db_open("test.db", DB_BTREE, 
		   DB_CREATE, 0600, NULL, NULL, &db);
     if(ret) {
	  perror("db_open");
	  exit(EXIT_FAILURE);
     }
     
     /* κ */
     ret = db->cursor(db, NULL, &dbc, 0);
     if(ret) {
	  perror("cursor");
	  exit(EXIT_FAILURE);
     }
     memset(&key, 0, sizeof(key));
     memset(&value, 0, sizeof(value));

     /* ǡ١Ϣ³ưư */
     while((ret = dbc->c_get(dbc, &key, &value, DB_NEXT)) != DB_NOTFOUND)
	  printf("ͤ %s/%s\n", (char *)key.data, 
		 (char *)value.data);

     /* ǡ١ƱȤ */
     db->sync(db, 0);

     /* Ĥ */
     dbc->c_close(dbc);

     db->close(db, 0);
     exit(EXIT_SUCCESS);
}
