/*
 * deldb.c - Berkeley DB ǡ١쥳ɤ
 */
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include "db.h"

int main(void)
{
     DB *db;
     int ret;
     DBT key;

     ret = db_open("test.db", DB_BTREE, 
		   DB_CREATE, 0600, NULL, NULL, &db);
     if(ret) {
	  perror("dbopen");
	  exit(EXIT_FAILURE);
     }

     /* ǽ˥ */
     memset(&key, 0, sizeof(key));
     /* ĤФ */
     key.data = "one";
     key.size = strlen("one") + 1;
     /*  */
     ret = db->del(db, NULL, &key, 0);
     if(ret == DB_NOTFOUND) {
	  fprintf(stderr, " %s Ĥʤä\n", (char *)key.data);
	  exit(EXIT_FAILURE);
     } else if(ret) {
	  perror("del");
	  exit(EXIT_FAILURE);
     }
     
     db->close(db, 0);
     exit(EXIT_SUCCESS);
}
