/*
 * getdb.c - Berkeley DB ǡ١쥳ɤ
 */
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include "db.h"

int main(int argc, char *argv[])
{
     DB *db;
     int ret;
     DBT key, value;
     
     /* ޥɹԤǥ̾õ */
     if(argc != 2) {
	 puts("USAGE: getdb <>");
	 exit(EXIT_FAILURE);
     }

     ret = db_open("test.db", DB_BTREE, 
		   DB_CREATE, 0600, NULL, NULL, &db);
     if(ret) {
	  perror("db_open");
	  exit(EXIT_FAILURE);
     }

     /* ǽ˥(key/value)Υڥ */
     memset(&key, 0, sizeof(key));
     memset(&value, 0, sizeof(value));

     /* ͤꤹ */
     key.data = argv[1];
     key.size = strlen(argv[1]) + 1;
     /* 򽦤Ф */
     ret = db->get(db, NULL, &key, &value, 0);
     if(ret == DB_NOTFOUND) 
	  fprintf(stderr, " %s Ĥʤ\n", (char *)key.data);
     else if(ret)
	  perror("get");
     else 
	  printf("ǡ: %s\n", (char *)value.data);
     
     
     db->close(db, 0);
     exit(EXIT_SUCCESS);
}
