/*
 * cursutil.c - cursesΥ桼ƥƥ롼
 */
#include <stdlib.h>
#include <curses.h>
#include <errno.h>
#include "utilfcns.h"

int main(void)
{
    WINDOW *win;
    FILE *fdump;
    int xmax, ymax, n = 0;

    app_init();

    if(!has_colors()) {
        printw("üϿ򥵥ݡȤʤ\n");
        refresh();
        sleep(3);
        app_exit();
 }
    if(start_color() == ERR)
         err_quit("start_color");
 
    init_pair(COLOR_RED, COLOR_RED, COLOR_BLACK);
    init_pair(COLOR_YELLOW, COLOR_YELLOW, COLOR_BLACK);
    init_pair(COLOR_WHITE, COLOR_WHITE, COLOR_BLACK);

    bkgd('#' | COLOR_PAIR(COLOR_RED));
    refresh();
    sleep(3);

    if((win = subwin(stdscr, 10, 10, 0, 0)) == NULL) 
         err_quit("subwin");
    wbkgd(win, '@' | COLOR_PAIR(COLOR_YELLOW));
    wrefresh(win);
    sleep(1);

    getmaxyx(stdscr, ymax, xmax);
    while(n < xmax - 10) {
        mvwin(win, ((ymax - 10) / 2), n);
        refresh();
        sleep(1);
        if(n == ((xmax - 10)/ 2)) {
             /* ֥ɥե˥פ */
             fdump = fopen("dump.win", "w");
             putwin(stdscr, fdump);
             fclose(fdump);
        }  
        n += 10;
    }
 
    fdump = fopen("dump.win", "r");
    win = getwin(fdump);
    wrefresh(win);
    sleep(3);

    clear();
    bkgd(' ' | COLOR_PAIR(COLOR_WHITE));
    mvprintw(1, 1, "ERASE character: %s\n", unctrl(erasechar()));
    mvprintw(2, 1, "KILL character : %s\n", unctrl(killchar()));
    mvprintw(3, 1, "BAUDRATE (bps) : %d\n", baudrate());
    mvprintw(4, 1, "TERMINAL type  : %s\n", termname());
    refresh();
    sleep(5);

    delwin(win);
    app_exit();
}
