/*
 * color.c - cursesο
 */
#include <stdlib.h>
#include <curses.h>
#include <errno.h>
#include <unistd.h>
#include "utilfcns.h"

int main(void)
{
    int n, maxx, maxy;
    char *str;
    
    app_init();
    
    if(!has_colors()) {
	printw("üϿ򥵥ݡȤʤ\n");
	refresh();
	sleep(3);
	exit(EXIT_FAILURE);
    }
    if(start_color() == ERR)
	err_quit("start_color");
    
    /* ñʿƤ򤤤Ĥꤹ */
    init_pair(COLOR_BLACK, COLOR_BLACK, COLOR_BLACK);
    init_pair(COLOR_GREEN, COLOR_GREEN, COLOR_BLACK);
    init_pair(COLOR_RED, COLOR_RED, COLOR_BLACK);
    init_pair(COLOR_CYAN, COLOR_CYAN, COLOR_BLACK);
    init_pair(COLOR_WHITE, COLOR_WHITE, COLOR_BLACK);
    init_pair(COLOR_MAGENTA, COLOR_MAGENTA, COLOR_BLACK);
    init_pair(COLOR_BLUE, COLOR_BLUE, COLOR_BLACK);
    init_pair(COLOR_YELLOW, COLOR_YELLOW, COLOR_BLACK);
    
    getmaxyx(stdscr, maxy, maxx);
    if((str = malloc(sizeof(char) * maxx)) == NULL)
	err_quit("malloc");
    
    for(n = 1; n <= 8; n++) {
	memset(str, ACS_BLOCK, maxx);
	attron(COLOR_PAIR(n));
	printw("%s", str);
	refresh();
    }
    sleep(3);
    
    app_exit();
    exit(EXIT_SUCCESS);
}
