/*
 * newwin.c - cursesΥ桼ƥƥ롼
 */
#include <stdlib.h>
#include <curses.h>
#include <errno.h>
#include <unistd.h>
#include "utilfcns.h"

int main(void)
{
    WINDOW *win;
    int ymax, xmax;

    app_init();

    if((win = newwin(15, 30, 1, 1)) == NULL) 
         err_quit("newwin");
    mvwprintw(win, 1,1, "NEW WINDOW");
	box(win, ACS_VLINE, ACS_HLINE);
    wrefresh(win);
    sleep(1);

	mvwin(win, 5, 10);
	werase(stdscr);
	refresh();
	wrefresh(win);
	sleep(2);

	getmaxyx(stdscr, ymax, xmax);
	mvwin(win, ymax - 16, xmax - 31);
	werase(stdscr);
	refresh();
	wrefresh(win);
	sleep(2);

    delwin(win);
    app_exit();
	exit(EXIT_FAILURE);
}
