/*
 * useform.c - ñʥեλȤμ
 */
#include <curses.h>
#include <form.h>
#include <stdlib.h>
#include <ctype.h>        /* isprint() */
#include "utilfcns.h"

int main(void)
{
    FORM *form;
    FIELD *fields[5];
    int ch, i = 0;

    /* curses򳫻Ϥ */
    app_init();
    cbreak();
    keypad(stdscr, TRUE);

    /* եեɤ */
    fields[0] = new_field(1, 12, 1, 1, 0, 0);
    set_field_buffer(fields[0], 0, "եȡ̾͡: ");
    set_field_opts(fields[0], field_opts(fields[0]) & ~O_ACTIVE);

    fields[1] = new_field(1, 20, 1, 14, 0, 0);
    set_field_userptr(fields[1], NULL);

    fields[2] = new_field(1, 12, 2, 1, 0, 0);
    set_field_buffer(fields[2], 0, "饹ȡ͡: ");
    set_field_opts(fields[2], field_opts(fields[2]) & ~O_ACTIVE);
    
    fields[3] = new_field(1, 20, 2, 14, 0, 0);
    set_field_userptr(fields[3], NULL);

    fields[4] = NULL;

    /* եŽĤ */
    form = new_form(fields);
    post_form(form);
    refresh();

    /* ޥɥ롼פ򳫻Ϥ */
    form_driver(form, REQ_OVL_MODE);
    while(toupper(ch = getch()) != KEY_F(10)) {
        if(ch == KEY_UP || ch == KEY_PPAGE)
            form_driver(form, REQ_PREV_FIELD);
        else if(ch == '\n' || ch == KEY_DOWN || ch == KEY_NPAGE)
            form_driver(form, REQ_NEXT_FIELD);
        else if(ch == KEY_BACKSPACE)
            form_driver(form, REQ_DEL_PREV);
        else if(isprint(ch))
            form_driver(form, ch);
        else
            form_driver(form, E_UNKNOWN_COMMAND);
    }

    unpost_form(form);
    free_form(form);
    for(i = 0; i < 5; i++)
        free_field(fields[i]);

    keypad(stdscr, FALSE);
    nocbreak();
    app_exit();
    exit(EXIT_FAILURE);
}
