/*
 * usemenu.c - ncurses˥塼λ
 */
#include <curses.h>
#include <menu.h>
#include <stdlib.h>
#include <ctype.h>
#include "utilfcns.h"

int main(void)
{
    static const char *beers[] =
    {
        "Budweiser", "Miller", "Pabst", "Schlitz", "MGD", "Coors",
        "Shiner", "Pearl", "Lone Star", "Rainer", "Carlson", NULL
    };
    const char **bp;
    int ch;
    ITEM *items[sizeof(beers)];
    ITEM **ip = items;
    MENU *mymenu;

    /* ncurses */
    app_init();

    /* 롿ե󥯥ΥϤ᤹ */
    keypad(stdscr, TRUE);

    /* ˥塼ܤ */
    for(bp = beers; *bp; bp++)
        *ip++ = new_item(*bp, "");
    *ip = NULL;

    /* ˥塼Ƚ */
    mymenu = new_menu(items);
    set_menu_format(mymenu, 5, 1);

    /* ˥塼ŽĤƥեå夹 */
    post_menu(mymenu);
    refresh();

    /* 桼qޤQ򲡤ޤǥ롼פ */
    while(toupper(ch = getch()) != 'Q') {
        if(ch == KEY_DOWN || ch == KEY_NPAGE)
            menu_driver(mymenu, REQ_DOWN_ITEM);
        else if(ch == KEY_UP || KEY_PPAGE)
            menu_driver(mymenu, REQ_UP_ITEM);
    }

    /* ˥塼Ȥ */
    unpost_menu(mymenu);

    /* ˥塼ȥ˥塼ܤ */
    free_menu(mymenu);
    for(ip = items; *ip; ip++)
        free_item(*ip);

    /* ncursesλ */
    keypad(stdscr, FALSE);
    app_exit();
    exit(EXIT_FAILURE);
}
