/* 
 * blkusr.c - SIGUSR1Υϥɥ
 */
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

void err_quit(char *); /* errؿ */
void hndl_usr1(int);   /* ʥϥɥ */

int main(void)
{
     struct sigaction action;
     
     /* ϥɥꤹ */
     action.sa_handler = hndl_usr1;
     sigemptyset(&action.sa_mask);
     action.sa_flags = SA_NOCLDSTOP;
     
     /* ϥɥϿ */
     if((sigaction(SIGUSR1, &action, NULL)) < 0)
	  err_quit("sigaction");
     /* ʥΤ˽ʬʻ */
     sleep(60);
     
     exit(EXIT_SUCCESS);
}

void err_quit(char *msg)
{
     perror(msg);
     exit(EXIT_FAILURE);
}

void hndl_usr1(int signum)
{
     if(signum == SIGUSR1)
	  puts("SIGUSR1ᤨ");
     else
	  printf("%dᤨ\n", signum);
}
