/* 
 * mplex.c - selectȤäpipe1pipe2ϥեɤ߽Ф
 * 
 * ޥ롦󥽥(Michael Johnson)ȥåȥ(Erik Troan)
 * 񤤤 mpx-select.c Ŭѡ"Linux Application Development", 
 * Michael Johnson and Erik Troan ԤǤξεĤƤλѡ 
 * /
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#define BUFSZ 80

void err_quit(char *msg);

int main(void)
{
    int fds[2];
    char buf[BUFSZ];
    int i, rc, maxfd;
    fd_set watchset;		/* Υե뵭һҤΥåȤɤ߽Ф */
    fd_set inset;		/* select򹹿Τwatchset򥳥ԡ */
    
    /* ѥפ򤽤줾쳫 */
    if((fds[0] = open("pipe1", O_RDONLY | O_NONBLOCK)) < 0)
	err_quit("open pipe1");
    if((fds[1] = open("pipe2", O_RDONLY | O_NONBLOCK)) < 0)
	err_quit("open pipe2");
    
    /* ʬΥե뵭һҤwatchset */
    FD_ZERO(&watchset);
    FD_SET(fds[0], &watchset);
    FD_SET(fds[1], &watchset);
    
    /* selectϺΥե뵭һҤΤɬפ */
    maxfd = fds[0] > fds[1] ? fds[0] : fds[1];
    
    /* Ϥɤ߽ФΥѥפĴ٤֥롼פ */
    while(FD_ISSET(fds[0], &watchset) || FD_ISSET(fds[1], &watchset)) {
	/* select˸ԤεһҤΥåȤ뤳Ȥǧ */
	inset = watchset;
	if(select(maxfd + 1, &inset, NULL, NULL, NULL) < 0)
	    err_quit("select");
	
	/* ɤΥե뵭һҤɽФǽ? */
	for(i = 0; i < 2; ++i) {
	    if(FD_ISSET(fds[i], &inset)) {
		rc = read(fds[i], buf, BUFSZ - 1);
		if(rc > 0) { /* ǡɤ߽Ф */
		    buf[rc] = '\0';
		    fprintf(stdout, "read: %s", buf);
		} else if(rc == 0) { /* ΥѥפĤƤ */
		    close(fds[i]);
		    FD_CLR(fds[i], &watchset);
		} else 
		    err_quit("read"); /* 󡢲줿 */
	    }
	}
    }
    exit(EXIT_SUCCESS);
}

void err_quit(char *msg)
{
    perror(msg);
    exit(EXIT_FAILURE);
}
