/*
 * setext2.c - ext2̤ʥե饰
 */
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <linux/ext2_fs.h>
#include <sys/ioctl.h>
#include <errno.h>

int main(int argc, char *argv[])
{
    int fd;
    long flags;
    
    /* 桼˸ƽФפФ */
    if(argc != 2) {
	puts("USAGE: setext2 {ե̾}");
	exit(EXIT_FAILURE);
    }
    
    if((fd = open(argv[1], O_RDONLY)) < 0) {
	perror("open");
	exit(EXIT_FAILURE);
    }
    
    /* ԤϥեꤹͽΥե饰 */
    flags = EXT2_SYNC_FL | EXT2_NODUMP_FL;
    /* ե饰ꤹȡԤƤ⤦ޤڤȴ */
    if(ioctl(fd, EXT2_IOC_SETFLAGS, &flags)) {
	perror("ioctl");
	close(fd);
	exit(EXIT_FAILURE);
    }
    
    if(flags & EXT2_SYNC_FL)
	puts("SYNCե饰ꤵ줿");
    if(flags & EXT2_NODUMP_FL)
	puts("NODUMPե饰ꤵ줿");
    
    close(fd);
    exit(EXIT_SUCCESS);
}
