/*
 * color.c - cursesο
 */
#include <stdlib.h>
#include <curses.h>
#include <errno.h>
#include "utilfcns.h"

int main(void)
{
    int n;

    app_init();

    if(has_colors()) {
        if(start_color() == ERR)
            err_quit("start_color");

        /* ñʿƤ򤤤Ĥꤹ */
        init_pair(COLOR_BLACK, COLOR_BLACK, COLOR_BLACK);
        init_pair(COLOR_GREEN, COLOR_GREEN, COLOR_BLACK);
        init_pair(COLOR_RED, COLOR_RED, COLOR_BLACK);
        init_pair(COLOR_CYAN, COLOR_CYAN, COLOR_BLACK);
        init_pair(COLOR_WHITE, COLOR_WHITE, COLOR_BLACK);
        init_pair(COLOR_MAGENTA, COLOR_MAGENTA, COLOR_BLACK);
        init_pair(COLOR_BLUE, COLOR_BLUE, COLOR_BLACK);
        init_pair(COLOR_YELLOW, COLOR_YELLOW, COLOR_BLACK);

        for(n = 1; n <= 8; n++) {
            attron(COLOR_PAIR(n));
            printw("NORMAL⡼ɤοڥ%d\n", n);
            attron(COLOR_PAIR(n) | A_STANDOUT);
            printw("STANDOUT⡼ɤοڥ%d\n", n);
            attroff(A_STANDOUT);
            refresh();
        }
        sleep(10);
    }
    else {
        printw("ü򥵥ݡȤʤ\n");
        refresh();
        sleep(3);
    }
 
    app_exit();
}
