/*
 * cursinch.c - ncursesʸϥե󥯥
 */
#include <stdlib.h>
#include <curses.h>
#include <errno.h>
#include "utilfcns.h"

int main(void)
{
    int c, i = 0;
    int xmax, ymax;
    char str[80];
    WINDOW *pwin;

    app_init();
    crmode();

    getmaxyx(stdscr, ymax, xmax);
    if((pwin = subwin(stdscr, 3, 40, ymax / 3, (xmax - 40) / 2 )) == NULL) {
        perror("subwin");
		exit(EXIT_FAILURE);
	}
    box(pwin, ACS_VLINE, ACS_HLINE);
    mvwaddstr(pwin, 1, 1, "ѥ: ");

    noecho();
    while((c = getch()) != '\n' && i < 80) {
        str[i++] = c;
        waddch(pwin, '*');
        wrefresh(pwin);
    }
    echo();
    str[i] = '\0';
    wrefresh(pwin);

    mvwprintw(pwin, 1, 1, "Τ褦˥פ줿: %s\n", str);
    box(pwin, ACS_VLINE, ACS_HLINE);
    wrefresh(pwin);
    sleep(3);

    delwin(pwin);
    app_exit();
}
