/* 
 * lpeplay.c - ǥ
 */
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>		/* strerror */
#include <errno.h>		/* errno */

#define BUFSZ 4096

int main(void)
{
    int devfd, sampfd;		/* ե뵭һ */
    int len;			/* ɽФ */
    int format, speed, stereo;	/* ioctlsѤΰ */
    char *dev = "/dev/dsp"; 
    unsigned char sampbuf[BUFSZ]; /* ץѤΥХåե */
     
    /* ѥ᡼ */
    speed = 8000;
    stereo = 0;
    format = AFMT_QUERY;

    /* /dev/dsp 򳫤 */
    if((devfd = open(dev, O_WRONLY)) < 0) {
	if(errno == EBUSY) {
	    fprintf(stderr, "%s in use\n", dev);
	}
	fprintf(stderr, "%s: %s\n", dev, strerror(errno));
	exit(EXIT_FAILURE);
    }
     
    /* ߥݡȤƤ񼰤ϲ? */
    if((ioctl(devfd, SNDCTL_DSP_GETFMTS, &format)) < 0) {
	perror("SNDCTL_DSP_GETFMTS");
	exit(EXIT_FAILURE);
    }
    /*
     * Ԥͭʽ񼰤ꥹȤ롣
     * ˳ʹɡ뤳ȤϤ롣
     */
    puts("/dev/dsp θ:");
    if(format & AFMT_MU_LAW)    puts("\tAFMT_MU_LAW");
    if(format & AFMT_A_LAW)     puts("\tAFMT_A_LAW");
    if(format & AFMT_IMA_ADPCM) puts("\tAFMT_IMA_ADPCM");
    if(format & AFMT_U8)        puts("\tAFMT_U8");
    if(format & AFMT_S16_LE)    puts("\tAFMT_S16_LE");
    if(format & AFMT_S16_BE)    puts("\tAFMT_S16_BE");
    if(format & AFMT_S8)        puts("\tAFMT_S8");
    if(format & AFMT_U16_LE)    puts("\tAFMT_U16_LE");
    if(format & AFMT_U16_BE)    puts("\tAFMT_U16_BE");
    if(format & AFMT_MPEG)      puts("\tAFMT_MPEG");
     
    /* ͥꤹ */
    if((ioctl(devfd, SNDCTL_DSP_STEREO, &stereo)) < 0) {
	perror("SNDCTL_DSP_STEREO");
	exit(EXIT_FAILURE);
    }
    printf("\tSet %s mode\n", stereo ? "STEREO" : "MONO");
	  
    /* ץ륹ԡɤꤹ */
    if((ioctl(devfd, SNDCTL_DSP_SPEED, &speed)) < 0) {
	perror("SNDCTL_DSP_SPEED");
	exit(EXIT_FAILURE);
    }
    printf("\tSPEED %d Hz\n", speed);
     
    /* 뤿˥ץ롦եɤ߹ */
    if((sampfd = open("8000.wav", O_RDONLY)) < 0) {
	perror("open 8000.wav");
	exit(EXIT_FAILURE);
    }

    /* 1֥åɽФơ1֥å񤭹 */
    while((len = read(sampfd, sampbuf, BUFSZ)) > 0)
	write(devfd, sampbuf, len);
     
    /* һҤĤơФƤ椯 */
    close(devfd);
    close(sampfd);
    exit(EXIT_SUCCESS);
}
