/*
 * hostinfo.c - ۥ̾hostent¤Τɽ
 */
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdlib.h>
#include <stdio.h>
#include "helper.h"

int main(int argc, char *argv[])
{
     struct hostent *buf;
     struct in_addr **paddr;
     char **palias;

     /* ޥɥ饤IPɥ쥹Ԥ */
     if(argc != 2) {
	  puts("USAGE: hostinfo <host name>");
	  exit(EXIT_FAILURE);
     }
     
     /* ɬĴ٤Ƥߤ */
     if((buf = gethostbyname(argv[1])) == NULL)
	  herr_quit("gethostbyname");
     /* ʥۥ̾Τǡ... */
     printf("%sΥۥȾ\n", argv[1]);

     /* ʥۥ̾*/
     printf("̾: %s\n", buf->h_name);

     /* Ƥ̾ */
     puts("̾:");
     palias = buf->h_aliases;
     while(*palias) {
	  printf("\t%s\n", *palias);
	  palias++;
     }

     /* ˾ޤh_addrtypeAF_INETǤ */
     if(buf->h_addrtype == AF_INET)
	  puts(": AF_INET");
     else
	  puts(": Τʤ");
     printf("Ĺ: %d\n", buf->h_length);

     /* All of the IP addresses IPɥ쥹*/
     puts("ɥ쥹:");
     paddr = (struct in_addr **)buf->h_addr_list;
     while(*paddr) {
	  printf("\t%s\n", inet_ntoa(**paddr));
	  paddr++;
     }

     exit(EXIT_SUCCESS);
}
